<$INCLUDE FILE="inc/macro.hsc">
<WEBPAGE chapter="hsc - " title="Options">

<* macro to format an explanation *>
<$MACRO explan NAME:string>
<DT><B><$INSERT TEXT=<name>></B>
<DD>
</$MACRO>
<* macro to format an example *>
<$MACRO example EXMP:string>
<DT><TT><$INSERT TEXT=<exmp>></TT>
<DD>
</$MACRO>

All options and swiches are case-insensitive. If you start <hsc>
without any options, a short help message will be displayed.<P>

<hsc> understands the following options:<P>

<DL>
<EXPLAN NAME="Help">
    Display a short help message.
<EXPLAN NAME="[from=]<I>infile</I>">
    Specifies the input filename. To use <TT>stdin</TT> as
    input file, see PipeIn.
<EXPLAN NAME="[to=]<I>outfile</I>">
    Specifies the output filename. If no output file is given, <TT>stdout</TT>
    is used instead.
<EXPLAN NAME="DestDir=<I>destination_directory</I>">
    Specifies the destination directory for output file.
<EXPLAN NAME="Errfile=<I>errfile</I>">
    Redirects error output to a file. By default, <TT>stderr</TT> ist used.
<EXPLAN NAME="Ignore=IGN">
    Ignore warning message number. Numeric, can occure multiple.
    (eg <TT>IGN=21 IGN=18</TT>.)

</DL>

<H1>Switches</H1>
<DL>
<EXPLAN name="AbsUri">
    Enable <A HREF="features/absuris.html">Absolute URIs</A>
<EXPLAN NAME="CheckUri">
    <A HREF="features/checkuri.html">Check existence</A> of local URIs
<*<EXPLAN NAME="PipeIn">
    Read input file from <TT>stdin</TT>*>
<EXPLAN NAME="RplcEnt">
    <A HREF="features/rplcent.html">Replace special charaters</A> with its entity (eg "&uuml;"
    becomes "&amp;uuml").
<EXPLAN NAME="SmartEnt">
    Replace special charaters "&amp;", "&lt;", "&gt;", "\"" (quote) with its entity
    (<CODE>&amp;amp;, &amp;lt;, &amp;gt; &amp;quot;</CODE>) if they are
    surrounded by white-spaces.
<EXPLAN NAME="Status">
    Display file and line number during conversion. Included files
    are also displayed. After processing a file, the filename and
    the total number of lines remain visible. (output goes to stderr.)
<EXPLAN NAME="Verbose">
    More verbose status output. Enables the Status-switch.
</DL>

<H1>Examples</H1>
<DL>
<EXAMPLE exmp="hsc FROM hugo.html TO t:">
    Simly performs a syntax check on <FILE>hugo.html</FILE> and writes
    a dummy-output to the temporary directory.
<EXAMPLE exmp="hsc hugo.html t: STATUS RPLCENT">
    Same as above, but also displays a status message during conversion.
    Additionally, all special characters like "&Uuml;" or "&szlig;" are
    replaced by its entities ("<TT>&amp;Uuml;</TT>" and
    "<TT>&amp;szlig;</TT>")
<EXAMPLE exmp="hsc FROM people/hugo.hsc DESTDIR /pub_html STATUS ABSURI">
    Process subfile <FILE>people/hugo.hsc</FILE>. The current directory is the
    main directory of the project. The HTML-object is created in
    <FILE>/pub_html/people/hugo.hsc</FILE>. All local URIs referenced within
    <FILE>hugo.hsc</FILE> are interpreted as <A HREF="features/absuris.html">
    absolut URIs</A> and are converted to relative path when written to
    the HTML-object.
<EXAMPLE exmp="hsc FROM people/hugo.hsc DESTDIR /pub_html STATUS ABSURI CHECKURI">
    Same as above. Additionally, all URIs referenced are checked for existence.
    If eg, <FILE>people/hugo.hsc</FILE> references to <FILE>prog/project/thing.hsc</FILE>,
    the file <FILE>/pub_html/project/thing.html</FILE> must exist or an error will
    occure.<BR>
    <STRONG>Note</STRONG>: Also mind that the HSC-source ends with ".hsc", but
    the HTML-object automatically gets the extension ".html". Therefor, all
    references must end with ".html".
</DL>

<P>

<MAIN>
<PREV href="features/rplcent.html">
<NEXT href="errors.html">
</WEBPAGE>

